import abc
import os
import unittest

from integration.partial.integration_test_utils import IntegrationTestUtils


class BaseSurveyTestSuite:

    class SurveyTestSuite(unittest.TestCase):

        TEST_OUT_PATH: str = None
        TEST_START_DATE: str = None
        TEST_JOB_DIR: str = None

        @abc.abstractmethod
        def set_expected_values(self):
            pass


        def test_standard_run_input_status_success(self):
            status_file_path = os.path.join(BaseSurveyTestSuite.SurveyTestSuite.TEST_OUT_PATH,
                                            BaseSurveyTestSuite.SurveyTestSuite.TEST_JOB_DIR, "STATUS_SUCCESS")
            success_file_exists: bool = os.path.isfile(status_file_path)
            self.assertTrue(success_file_exists)


        def test_standard_run_input_merged_survey_created(self):
            status_file_path = os.path.join(BaseSurveyTestSuite.SurveyTestSuite.TEST_OUT_PATH,
                                            BaseSurveyTestSuite.SurveyTestSuite.TEST_JOB_DIR,
                                            "ExportCSV", "Merged_SurveyData.csv")
            success_file_exists: bool = os.path.isfile(status_file_path)
            file_not_empty: bool = IntegrationTestUtils.check_file_not_empty(status_file_path)
            self.assertTrue(success_file_exists)
            self.assertTrue(file_not_empty)